# Sinusoide (PNL)

# DATI
param n;						# Numero di osservazioni
set N := 1..n;				# Insieme indicizzato delle osservazioni
param t {N};					# Istante di tempo di ogni osservazione [s]
param y {N};					# Valore osservato [m]
param pigreco := 3.14159;

# VARIABILI
var A >=0, := max {i in N} abs(y[i]);		# Ampiezza della sinusoide [m]
var b := 0;									# Valor medio della sinusoide [m]
var omega >=0, <=100*pigreco, := 8*pigreco;	# Pulsazione della sinusoide [rad/s]
var phi >=0, <=2*pigreco, :=0;				# Fase della sinusoide [rad]
var e {i in N} = y[i] - (A * sin (omega * t[i] + phi) + b);

# OBIETTIVO
minimize z: 1/n * sum {i in N} e[i]^2;

#########################
data;

param n := 12;

param: t    y    :=
 1	   2	  -9.776
 2	   5	 -10.452
 3	   8	  -6.183
 4	  11	   0.528
 5	  12	 -10.921
 6	  16	  -7.833
 7	  22	  -8.578
 8	  24	   5.845
 9	  27	   1.211
10	  31	   5.925
11	  39	  -5.166
12	  41	   3.963;
	
end;
